#include "av_geo.h"


const struct GeoData DGRF2000[] = {
	{ -29619.4f,      0.0f,      0.0f,      0.0f },
	{  -1728.2f,   5186.1f,      0.0f,      0.0f },
	{  -2267.7f,      0.0f,      0.0f,      0.0f },
	{   3068.4f,  -2481.6f,      0.0f,      0.0f },
	{   1670.9f,   -458.0f,      0.0f,      0.0f },
	{   1339.6f,      0.0f,      0.0f,      0.0f },
	{  -2288.0f,   -227.6f,      0.0f,      0.0f },
	{   1252.1f,    293.4f,      0.0f,      0.0f },
	{    714.5f,   -491.1f,      0.0f,      0.0f },
	{    932.3f,      0.0f,      0.0f,      0.0f },
	{    786.8f,    272.6f,      0.0f,      0.0f },
	{    250.0f,   -231.9f,      0.0f,      0.0f },
	{   -403.0f,    119.8f,      0.0f,      0.0f },
	{    111.3f,   -303.8f,      0.0f,      0.0f },
	{   -218.8f,      0.0f,      0.0f,      0.0f },
	{    351.4f,     43.8f,      0.0f,      0.0f },
	{    222.3f,    171.9f,      0.0f,      0.0f },
	{   -130.4f,   -133.1f,      0.0f,      0.0f },
	{   -168.6f,    -39.3f,      0.0f,      0.0f },
	{    -12.9f,    106.3f,      0.0f,      0.0f },
	{     72.3f,      0.0f,      0.0f,      0.0f },
	{     68.2f,    -17.4f,      0.0f,      0.0f },
	{     74.2f,     63.7f,      0.0f,      0.0f },
	{   -160.9f,     65.1f,      0.0f,      0.0f },
	{     -5.9f,    -61.2f,      0.0f,      0.0f },
	{     16.9f,      0.7f,      0.0f,      0.0f },
	{    -90.4f,     43.8f,      0.0f,      0.0f },
	{     79.0f,      0.0f,      0.0f,      0.0f },
	{    -74.0f,    -64.6f,      0.0f,      0.0f },
	{      0.0f,    -24.2f,      0.0f,      0.0f },
	{     33.3f,      6.2f,      0.0f,      0.0f },
	{      9.1f,     24.0f,      0.0f,      0.0f },
	{      6.9f,     14.8f,      0.0f,      0.0f },
	{      7.3f,    -25.4f,      0.0f,      0.0f },
	{     -1.2f,     -5.8f,      0.0f,      0.0f },
	{     24.4f,      0.0f,      0.0f,      0.0f },
	{      6.6f,     11.9f,      0.0f,      0.0f },
	{     -9.2f,    -21.5f,      0.0f,      0.0f },
	{     -7.9f,      8.5f,      0.0f,      0.0f },
	{    -16.6f,    -21.5f,      0.0f,      0.0f },
	{      9.1f,     15.5f,      0.0f,      0.0f },
	{      7.0f,      8.9f,      0.0f,      0.0f },
	{     -7.9f,    -14.9f,      0.0f,      0.0f },
	{     -7.0f,     -2.1f,      0.0f,      0.0f },
	{      5.0f,      0.0f,      0.0f,      0.0f },
	{      9.4f,    -19.7f,      0.0f,      0.0f },
	{      3.0f,     13.4f,      0.0f,      0.0f },
	{     -8.4f,     12.5f,      0.0f,      0.0f },
	{      6.3f,     -6.2f,      0.0f,      0.0f },
	{     -8.9f,     -8.4f,      0.0f,      0.0f },
	{     -1.5f,      8.4f,      0.0f,      0.0f },
	{      9.3f,      3.8f,      0.0f,      0.0f },
	{     -4.3f,     -8.2f,      0.0f,      0.0f },
	{     -8.2f,      4.8f,      0.0f,      0.0f },
	{     -2.6f,      0.0f,      0.0f,      0.0f },
	{     -6.0f,      1.7f,      0.0f,      0.0f },
	{      1.7f,      0.0f,      0.0f,      0.0f },
	{     -3.1f,      4.0f,      0.0f,      0.0f },
	{     -0.5f,      4.9f,      0.0f,      0.0f },
	{      3.7f,     -5.9f,      0.0f,      0.0f },
	{      1.0f,     -1.2f,      0.0f,      0.0f },
	{      2.0f,     -2.9f,      0.0f,      0.0f },
	{      4.2f,      0.2f,      0.0f,      0.0f },
	{      0.3f,     -2.2f,      0.0f,      0.0f },
	{     -1.1f,     -7.4f,      0.0f,      0.0f },
	{      2.7f,      0.0f,      0.0f,      0.0f },
	{     -1.7f,      0.1f,      0.0f,      0.0f },
	{     -1.9f,      1.3f,      0.0f,      0.0f },
	{      1.5f,     -0.9f,      0.0f,      0.0f },
	{     -0.1f,     -2.6f,      0.0f,      0.0f },
	{      0.1f,      0.9f,      0.0f,      0.0f },
	{     -0.7f,     -0.7f,      0.0f,      0.0f },
	{      0.7f,     -2.8f,      0.0f,      0.0f },
	{      1.7f,     -0.9f,      0.0f,      0.0f },
	{      0.1f,     -1.2f,      0.0f,      0.0f },
	{      1.2f,     -1.9f,      0.0f,      0.0f },
	{      4.0f,     -0.9f,      0.0f,      0.0f },
	{     -2.2f,      0.0f,      0.0f,      0.0f },
	{     -0.3f,     -0.4f,      0.0f,      0.0f },
	{      0.2f,      0.3f,      0.0f,      0.0f },
	{      0.9f,      2.5f,      0.0f,      0.0f },
	{     -0.2f,     -2.6f,      0.0f,      0.0f },
	{      0.9f,      0.7f,      0.0f,      0.0f },
	{     -0.5f,      0.3f,      0.0f,      0.0f },
	{      0.3f,      0.0f,      0.0f,      0.0f },
	{     -0.3f,      0.0f,      0.0f,      0.0f },
	{     -0.4f,      0.3f,      0.0f,      0.0f },
	{     -0.1f,     -0.9f,      0.0f,      0.0f },
	{     -0.2f,     -0.4f,      0.0f,      0.0f },
	{     -0.4f,      0.8f,      0.0f,      0.0f },
	{     -0.2f,      0.0f,      0.0f,      0.0f },
	{     -0.9f,     -0.9f,      0.0f,      0.0f },
	{      0.3f,      0.2f,      0.0f,      0.0f },
	{      0.1f,      1.8f,      0.0f,      0.0f },
	{     -0.4f,     -0.4f,      0.0f,      0.0f },
	{      1.3f,     -1.0f,      0.0f,      0.0f },
	{     -0.4f,     -0.1f,      0.0f,      0.0f },
	{      0.7f,      0.7f,      0.0f,      0.0f },
	{     -0.4f,      0.3f,      0.0f,      0.0f },
	{      0.3f,      0.6f,      0.0f,      0.0f },
	{     -0.1f,      0.3f,      0.0f,      0.0f },
	{      0.4f,     -0.2f,      0.0f,      0.0f },
	{      0.0f,     -0.5f,      0.0f,      0.0f },
	{      0.1f,     -0.9f,      0.0f,      0.0f },
};

const struct GeoData DGRF2005[] = {
	{ -29554.6f,      0.0f,      0.0f,      0.0f },
	{  -1669.0f,   5078.0f,      0.0f,      0.0f },
	{  -2337.2f,      0.0f,      0.0f,      0.0f },
	{   3047.7f,  -2594.5f,      0.0f,      0.0f },
	{   1657.8f,   -515.4f,      0.0f,      0.0f },
	{   1336.3f,      0.0f,      0.0f,      0.0f },
	{  -2305.8f,   -198.9f,      0.0f,      0.0f },
	{   1246.4f,    269.7f,      0.0f,      0.0f },
	{    672.5f,   -524.7f,      0.0f,      0.0f },
	{    920.5f,      0.0f,      0.0f,      0.0f },
	{    798.0f,    282.1f,      0.0f,      0.0f },
	{    210.7f,   -225.2f,      0.0f,      0.0f },
	{   -379.9f,    145.2f,      0.0f,      0.0f },
	{    100.0f,   -305.4f,      0.0f,      0.0f },
	{   -227.0f,      0.0f,      0.0f,      0.0f },
	{    354.4f,     42.7f,      0.0f,      0.0f },
	{    208.9f,    180.2f,      0.0f,      0.0f },
	{   -136.5f,   -123.5f,      0.0f,      0.0f },
	{   -168.1f,    -19.6f,      0.0f,      0.0f },
	{    -13.6f,    103.8f,      0.0f,      0.0f },
	{     73.6f,      0.0f,      0.0f,      0.0f },
	{     69.6f,    -20.3f,      0.0f,      0.0f },
	{     76.7f,     54.8f,      0.0f,      0.0f },
	{   -151.3f,     63.6f,      0.0f,      0.0f },
	{    -14.6f,    -63.5f,      0.0f,      0.0f },
	{     14.6f,      0.2f,      0.0f,      0.0f },
	{    -86.4f,     50.9f,      0.0f,      0.0f },
	{     79.9f,      0.0f,      0.0f,      0.0f },
	{    -74.5f,    -61.1f,      0.0f,      0.0f },
	{     -1.6f,    -22.6f,      0.0f,      0.0f },
	{     38.7f,      6.8f,      0.0f,      0.0f },
	{     12.3f,     25.4f,      0.0f,      0.0f },
	{      9.4f,     10.9f,      0.0f,      0.0f },
	{      5.4f,    -26.3f,      0.0f,      0.0f },
	{      1.9f,     -4.6f,      0.0f,      0.0f },
	{     24.8f,      0.0f,      0.0f,      0.0f },
	{      7.6f,     11.2f,      0.0f,      0.0f },
	{    -11.7f,    -20.9f,      0.0f,      0.0f },
	{     -6.9f,      9.8f,      0.0f,      0.0f },
	{    -18.1f,    -19.7f,      0.0f,      0.0f },
	{     10.2f,     16.2f,      0.0f,      0.0f },
	{      9.4f,      7.6f,      0.0f,      0.0f },
	{    -11.2f,    -12.8f,      0.0f,      0.0f },
	{     -4.9f,     -0.1f,      0.0f,      0.0f },
	{      5.6f,      0.0f,      0.0f,      0.0f },
	{      9.8f,    -20.1f,      0.0f,      0.0f },
	{      3.6f,     12.7f,      0.0f,      0.0f },
	{     -6.9f,     12.7f,      0.0f,      0.0f },
	{      5.0f,     -6.7f,      0.0f,      0.0f },
	{    -10.8f,     -8.2f,      0.0f,      0.0f },
	{     -1.2f,      8.1f,      0.0f,      0.0f },
	{      8.8f,      2.9f,      0.0f,      0.0f },
	{     -6.7f,     -7.7f,      0.0f,      0.0f },
	{     -9.2f,      6.0f,      0.0f,      0.0f },
	{     -2.2f,      0.0f,      0.0f,      0.0f },
	{     -6.1f,      2.2f,      0.0f,      0.0f },
	{      1.4f,      0.1f,      0.0f,      0.0f },
	{     -2.4f,      4.5f,      0.0f,      0.0f },
	{     -0.1f,      4.8f,      0.0f,      0.0f },
	{      3.1f,     -6.6f,      0.0f,      0.0f },
	{      0.3f,     -1.0f,      0.0f,      0.0f },
	{      2.1f,     -3.5f,      0.0f,      0.0f },
	{      3.8f,     -0.9f,      0.0f,      0.0f },
	{     -0.2f,     -2.3f,      0.0f,      0.0f },
	{     -2.1f,     -7.9f,      0.0f,      0.0f },
	{      3.0f,      0.0f,      0.0f,      0.0f },
	{     -1.6f,      0.3f,      0.0f,      0.0f },
	{     -1.9f,      1.4f,      0.0f,      0.0f },
	{      1.4f,     -0.8f,      0.0f,      0.0f },
	{     -0.3f,     -2.3f,      0.0f,      0.0f },
	{      0.3f,      0.9f,      0.0f,      0.0f },
	{     -0.8f,     -0.6f,      0.0f,      0.0f },
	{      0.5f,     -2.7f,      0.0f,      0.0f },
	{      1.8f,     -1.1f,      0.0f,      0.0f },
	{      0.2f,     -1.6f,      0.0f,      0.0f },
	{      1.0f,     -1.9f,      0.0f,      0.0f },
	{      4.0f,     -1.4f,      0.0f,      0.0f },
	{     -2.1f,      0.0f,      0.0f,      0.0f },
	{     -0.3f,     -0.6f,      0.0f,      0.0f },
	{      0.2f,      0.2f,      0.0f,      0.0f },
	{      0.9f,      2.4f,      0.0f,      0.0f },
	{     -0.4f,     -2.6f,      0.0f,      0.0f },
	{      1.0f,      0.6f,      0.0f,      0.0f },
	{     -0.3f,      0.4f,      0.0f,      0.0f },
	{      0.5f,      0.0f,      0.0f,      0.0f },
	{     -0.3f,      0.0f,      0.0f,      0.0f },
	{     -0.4f,      0.3f,      0.0f,      0.0f },
	{      0.1f,     -0.9f,      0.0f,      0.0f },
	{     -0.5f,     -0.3f,      0.0f,      0.0f },
	{     -0.1f,      0.9f,      0.0f,      0.0f },
	{     -0.2f,      0.0f,      0.0f,      0.0f },
	{     -0.9f,     -0.8f,      0.0f,      0.0f },
	{      0.3f,      0.3f,      0.0f,      0.0f },
	{      0.3f,      1.7f,      0.0f,      0.0f },
	{     -0.4f,     -0.5f,      0.0f,      0.0f },
	{      1.2f,     -1.1f,      0.0f,      0.0f },
	{     -0.4f,     -0.0f,      0.0f,      0.0f },
	{      0.8f,      0.6f,      0.0f,      0.0f },
	{     -0.3f,      0.2f,      0.0f,      0.0f },
	{      0.3f,      0.5f,      0.0f,      0.0f },
	{     -0.1f,      0.4f,      0.0f,      0.0f },
	{      0.4f,     -0.2f,      0.0f,      0.0f },
	{     -0.1f,     -0.6f,      0.0f,      0.0f },
	{     -0.2f,     -0.8f,      0.0f,      0.0f },
};

const struct GeoData IGRF2010[] = {
	{ -29496.5f,      0.0f,     11.4f,      0.0f },
	{  -1585.9f,   4945.1f,     16.7f,    -28.8f },
	{  -2396.6f,      0.0f,    -11.3f,      0.0f },
	{   3026.0f,  -2707.7f,     -3.9f,    -23.0f },
	{   1668.6f,   -575.4f,      2.7f,    -12.9f },
	{   1339.7f,      0.0f,      1.3f,      0.0f },
	{  -2326.3f,   -160.5f,     -3.9f,      8.6f },
	{   1231.7f,    251.7f,     -2.9f,     -2.9f },
	{    634.2f,   -536.8f,     -8.1f,     -2.1f },
	{    912.6f,      0.0f,     -1.4f,      0.0f },
	{    809.0f,    286.4f,      2.0f,      0.4f },
	{    166.6f,   -211.2f,     -8.9f,      3.2f },
	{   -357.1f,    164.4f,      4.4f,      3.6f },
	{     89.7f,   -309.2f,     -2.3f,     -0.8f },
	{   -231.1f,      0.0f,     -0.5f,      0.0f },
	{    357.2f,     44.7f,      0.5f,      0.5f },
	{    200.3f,    188.9f,     -1.5f,      1.5f },
	{   -141.2f,   -118.1f,     -0.7f,      0.9f },
	{   -163.1f,      0.1f,      1.3f,      3.7f },
	{     -7.7f,    100.9f,      1.4f,     -0.6f },
	{     72.8f,      0.0f,     -0.3f,      0.0f },
	{     68.6f,    -20.8f,     -0.3f,     -0.1f },
	{     76.0f,     44.2f,     -0.3f,     -2.1f },
	{   -141.4f,     61.5f,      1.9f,     -0.4f },
	{    -22.9f,    -66.3f,     -1.6f,     -0.5f },
	{     13.1f,      3.1f,     -0.2f,      0.8f },
	{    -77.9f,     54.9f,      1.8f,      0.5f },
	{     80.4f,      0.0f,      0.2f,      0.0f },
	{    -75.0f,    -57.8f,     -0.1f,      0.6f },
	{     -4.7f,    -21.2f,     -0.6f,      0.3f },
	{     45.3f,      6.6f,      1.4f,     -0.2f },
	{     14.0f,     24.9f,      0.3f,     -0.1f },
	{     10.4f,      7.0f,      0.1f,     -0.8f },
	{      1.6f,    -27.7f,     -0.8f,     -0.3f },
	{      4.9f,     -3.4f,      0.4f,      0.2f },
	{     24.3f,      0.0f,     -0.1f,      0.0f },
	{      8.2f,     10.9f,      0.1f,      0.0f },
	{    -14.5f,    -20.0f,     -0.5f,      0.2f },
	{     -5.7f,     11.9f,      0.3f,      0.5f },
	{    -19.3f,    -17.4f,     -0.3f,      0.4f },
	{     11.6f,     16.7f,      0.3f,      0.1f },
	{     10.9f,      7.1f,      0.2f,     -0.1f },
	{    -14.1f,    -10.8f,     -0.5f,      0.4f },
	{     -3.7f,      1.7f,      0.2f,      0.4f },
	{      5.4f,      0.0f,      0.0f,      0.0f },
	{      9.4f,    -20.5f,      0.0f,      0.0f },
	{      3.4f,     11.6f,      0.0f,      0.0f },
	{     -5.3f,     12.8f,      0.0f,      0.0f },
	{      3.1f,     -7.2f,      0.0f,      0.0f },
	{    -12.4f,     -7.4f,      0.0f,      0.0f },
	{     -0.8f,      8.0f,      0.0f,      0.0f },
	{      8.4f,      2.2f,      0.0f,      0.0f },
	{     -8.4f,     -6.1f,      0.0f,      0.0f },
	{    -10.1f,      7.0f,      0.0f,      0.0f },
	{     -2.0f,      0.0f,      0.0f,      0.0f },
	{     -6.3f,      2.8f,      0.0f,      0.0f },
	{      0.9f,     -0.1f,      0.0f,      0.0f },
	{     -1.1f,      4.7f,      0.0f,      0.0f },
	{     -0.2f,      4.4f,      0.0f,      0.0f },
	{      2.5f,     -7.2f,      0.0f,      0.0f },
	{     -0.3f,     -1.0f,      0.0f,      0.0f },
	{      2.2f,     -4.0f,      0.0f,      0.0f },
	{      3.1f,     -2.0f,      0.0f,      0.0f },
	{     -1.0f,     -2.0f,      0.0f,      0.0f },
	{     -2.8f,     -8.3f,      0.0f,      0.0f },
	{      3.0f,      0.0f,      0.0f,      0.0f },
	{     -1.5f,      0.1f,      0.0f,      0.0f },
	{     -2.1f,      1.7f,      0.0f,      0.0f },
	{      1.6f,     -0.6f,      0.0f,      0.0f },
	{     -0.5f,     -1.8f,      0.0f,      0.0f },
	{      0.5f,      0.9f,      0.0f,      0.0f },
	{     -0.8f,     -0.4f,      0.0f,      0.0f },
	{      0.4f,     -2.5f,      0.0f,      0.0f },
	{      1.8f,     -1.3f,      0.0f,      0.0f },
	{      0.2f,     -2.1f,      0.0f,      0.0f },
	{      0.8f,     -1.9f,      0.0f,      0.0f },
	{      3.8f,     -1.8f,      0.0f,      0.0f },
	{     -2.1f,      0.0f,      0.0f,      0.0f },
	{     -0.2f,     -0.8f,      0.0f,      0.0f },
	{      0.3f,      0.3f,      0.0f,      0.0f },
	{      1.0f,      2.2f,      0.0f,      0.0f },
	{     -0.7f,     -2.5f,      0.0f,      0.0f },
	{      0.9f,      0.5f,      0.0f,      0.0f },
	{     -0.1f,      0.6f,      0.0f,      0.0f },
	{      0.5f,      0.0f,      0.0f,      0.0f },
	{     -0.4f,      0.1f,      0.0f,      0.0f },
	{     -0.4f,      0.3f,      0.0f,      0.0f },
	{      0.2f,     -0.9f,      0.0f,      0.0f },
	{     -0.8f,     -0.2f,      0.0f,      0.0f },
	{      0.0f,      0.8f,      0.0f,      0.0f },
	{     -0.2f,      0.0f,      0.0f,      0.0f },
	{     -0.9f,     -0.8f,      0.0f,      0.0f },
	{      0.3f,      0.3f,      0.0f,      0.0f },
	{      0.4f,      1.7f,      0.0f,      0.0f },
	{     -0.4f,     -0.6f,      0.0f,      0.0f },
	{      1.1f,     -1.2f,      0.0f,      0.0f },
	{     -0.3f,     -0.1f,      0.0f,      0.0f },
	{      0.8f,      0.5f,      0.0f,      0.0f },
	{     -0.2f,      0.1f,      0.0f,      0.0f },
	{      0.4f,      0.5f,      0.0f,      0.0f },
	{      0.0f,      0.4f,      0.0f,      0.0f },
	{      0.4f,     -0.2f,      0.0f,      0.0f },
	{     -0.3f,     -0.5f,      0.0f,      0.0f },
	{     -0.3f,     -0.8f,      0.0f,      0.0f },
};


const struct GeoModel GEO_MODELS[] = {
	{ 2000.0f, 2005.0f,   -1.0f,  600.0f,  13,   0,   0, DGRF2000 },
	{ 2005.0f, 2010.0f,   -1.0f,  600.0f,  13,   0,   0, DGRF2005 },
	{ 2010.0f, 2015.0f,   -1.0f,  600.0f,  13,   8,   0, IGRF2010 },
};

const unsigned GEO_MODEL_COUNT = sizeof(GEO_MODELS) / sizeof(GEO_MODELS[0]);
